/*
 * kawnter.c - Katsuhiro's Web Access Counter (kawnter) version 0.1
 *
 *  Copyright (C) Katsuhiro Ueno 1999  <katsu@blue.sky.or.jp>
 *
 *   You can redistribute this program and/or modify it under
 *   either the terms of the Katsuhiro's Public License, or
 *   the terms of the GNU General Public License version 2.
 *
 *   THIS PROGRAM IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS
 *   OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE
 *   IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A
 *   PARTICULAR PURPOSE.
 *
 * $Id: kawnter.c,v 1.1 2000/03/26 12:47:38 katsu Exp $
 *
 */

/*
 * ¹Ԥ줿򥫥Ȥη̤ PNG β֤ޤ
 * 륢󥿡CGI httpd ȤäΤǡ
 * WebPage ȤŽդѤޤ
 *
 * ԥ奢ʤΤǤޤ
 * User-Agent ξͼפΤǵϿޤ
 * פ󤳤ȤʤΤư⿴(?)ڤä
 *
 * 1. Ѥ
 *   libpng (1.0.3ʹ)äơzlib ȤɬפˤʤäƤ櫓ǡ
 *   gcc -Wall -O2 -o count kawnter.c -lpng -lz -lm äƴ
 *    POSIX ǤǤʤȤ⤢ޤ ;-)
 *
 * 2. Ĥ
 *   Kawnter ϰڰȤޤɬפʾ PATH_INFO 
 *   ФΤ URI åꡢ HTML ⥹åꡢ
 *   㥭㥭ȤäλֲȤ
 *   ĥåߥ꡼ܥΥݡȤˤޤǼФäƤǤ
 *
 *   塼 PATH_INFO ʤʤ󤢤Τ˲ïȤʤ
 *   ȤפäƤޤκäꤹɡޤϤȤơ
 *
 *   /cgi-bin/  count ä̾ Kawnter ֤Ȥơ
 *   ºݤ˻ѤȤϤʴˤʤޤ
 *
 *     /cgi-bin/count/<user>/-<image>/<name>.png
 *
 *     <user>/  -<image>/ ϾάǤޤ
 *
 *       <user>:   桼ꡣȥե丵᡼
 *                 DEFAULT_ALIAS_DIR/<user>  ~<user>/.kawnter ʲ
 *                 Ф褦ˤޤ
 *                 `-' ǻϤޤΤԲġ`root' ͽ
 *                 ά DEFAULT_USER_DIR
 *
 *       <image>:  ᡼ꡣ<<user> ǻꤷ directory>/image
 *                  DEFAULT_IMAGE_DIR  <image>.png õ
 *                 ᡼Ȥޤ
 *                 ̵Ȥϥ顼λ
 *                 ᡼ 09 򲣰¤٤Τǡ
 *                 10ʬƺ 09 Υ᡼Ȥ
 *                 ⤵ϤΤޤ޽ϲι⤵ˤʤޤ
 *                 ά DEFAULT_IMAGE ꤵ줿ΤȤޤ
 *
 *       <name>:   ȥեꡣ<user>ǻꤷ directory 
 *                 <name> ȤեȾϿޤ
 *                 `_' ǻϤޤΤԲġ
 *                 `image', `aliases' ڤ `.' ǻϤޤΤͽ
 *                 άԲġ̵λϥ顼λ
 *
 *                 <name>  `_' ǻϤޤäƤ硢 `_' ޤǤδ֤
 *                 λȤߤʤޤ
 *                 1ʾοǤʤäά줿 DEFAULT_NUM_FIGURE
 *
 *        `.png' ϾάǤޤ
 *
 *  )
 *      /cgi-bin/count/katsu/-fb/hoge.png
 *      /cgi-bin/count/katsu/hoge.png
 *      /cgi-bin/count/-fb/hoge.png
 *      /cgi-bin/count/hoge.png
 *      /cgi-bin/count/katsu/-fb/_7_hoge.png
 *
 *  ͤϡޤ˥Ѥޤ (^-^)
 *
 *  ¾ܤȤϡʲΥɥȤˤȺ٤˽񤫤Ƥޤ()
 */


/* if defined, /etc/passwd is not checked to get user directory. */
/* #define SINGLE_USER_ONLY */

#define USER_DIR       ".kawnter"
#define IMAGE_DIR      "image"
#define ALIAS_DIR      "aliases"
#define USER_ROOT      "root"
#define SUFFIX         ".png"
#define DEFAULT_IMAGE  "default"

/* Default paths should be specified by absolute path. */
#define DEFAULT_USER_DIR   "/home/katsu/" USER_DIR
#define DEFAULT_IMAGE_DIR  DEFAULT_USER_DIR "/" IMAGE_DIR
#define DEFAULT_ALIAS_DIR  DEFAULT_USER_DIR "/" ALIAS_DIR

#define DEFAULT_NUM_FIGURE  6

#define DEFAULT_COMPRESSION_LEVEL   6      /* PNG compression level [0-9] */

#define LOCK_TIMEOUT      20     /* sec. */
#define FILE_MODE       0666



#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <pwd.h>
#include <errno.h>
/* #include <setjmp.h> */
#include <png.h>

typedef enum { false, true } boolean;
typedef enum { success, failed } status;

#define array_size(a)  (sizeof(a)/sizeof(a[0]))

#define _Try_
#define _Throw_(tag) goto __CATCH_##tag##_
#define _Catch_(tag) if(0) __CATCH_##tag##_:



#ifdef __GCC__
#define PRINTF_FORMAT(f,a)  __attribute__ ((format (printf, f, a)))
#else
#define PRINTF_FORMAT(f,a)  /* */
#endif

void error(int status, int errnum, const char *format, ...) PRINTF_FORMAT(2,3);




/*
 * ====== Global Variables ======
 */

const char *program_name;



/*
 * ====== Error Handler ======
 */
void error(int status, int errnum, const char *format, ...)
{
        va_list  ap;

        fflush(stdout);
        fprintf(stderr, "%s: ", program_name);

        if(format) {
                va_start(ap, format);
                vfprintf(stderr, format, ap);
                va_end(ap);
        }
        if(errnum) {
                if(format) fputs(": ", stderr);
                fputs(strerror(errnum), stderr);
        }

        fputs("\n", stderr);
        fflush(stderr);

        if(status) exit(status);
}




/*
 * ====== Memory Allocation ======
 */
void *xmalloc(size_t n)
{
        void  *p;
        p = malloc(n);
        if(!p) error(128, errno, "malloc %d bytes", n);
        return p;
}

char *xstrdup(const char *s)
{
        char  *dst;
        dst = strdup(s);
        if(!dst) error(129, errno, "xstrdup");
        return dst;
}




/*
 * ====== Chunks ======
 */

typedef struct __chunk  Chunk;

typedef Chunk* (*chunk_get_func)(Chunk*, png_structp, png_infop);
typedef void (*chunk_set_func)(Chunk*, png_structp, png_infop);
typedef void (*chunk_free_func)(Chunk*);
typedef void (*chunk_dump_func)(Chunk*, FILE*);

typedef struct {
        chunk_get_func   get;
        chunk_set_func   set;
        chunk_free_func  free;
} ChunkMethods;

struct __chunk {
        const char      *name;
        struct __chunk  *next;
        ChunkMethods    methods;
};

#define chunk_sizeof(chunk)   sizeof(chunk##_Chunk)

typedef struct {
        png_uint_32    flag;
        int            size;
        const char     *name;
        ChunkMethods   methods;
} ChunkTable;

#define REGIST_CHUNK(chunk) { \
        PNG_INFO_##chunk, chunk_sizeof(chunk), #chunk, { \
                (chunk_get_func)chunk##_get, \
                (chunk_set_func)chunk##_set, \
                (chunk_free_func)chunk##_free, \
        } \
}

#define _get  ,&this->
#define STD_CHUNK_GET(chunk, arg) \
void chunk##_get(chunk##_Chunk *this, png_structp png, png_infop pnginfo) { \
        png_get_##chunk(png, pnginfo arg); \
}
#define _set  ,this->
#define STD_CHUNK_SET(chunk, arg) \
void chunk##_set(chunk##_Chunk *this, png_structp png, png_infop pnginfo) { \
        png_set_##chunk(png, pnginfo arg); \
}


/*
 * PLTE chunk (palette)
 */
typedef struct {
        Chunk       head;
        png_colorp  palette;
        int         num_palette;
} PLTE_Chunk;

STD_CHUNK_SET(PLTE, _set palette  _set num_palette)

void PLTE_get(PLTE_Chunk *this, png_structp png, png_infop pnginfo)
{
        PLTE_Chunk  pal;
        int  size;

        png_get_PLTE(png, pnginfo, &pal.palette, &pal.num_palette);
        size = sizeof(png_color) * pal.num_palette;

        this->palette = xmalloc(size);
        memcpy(this->palette, pal.palette, size);
        this->num_palette = pal.num_palette;
}

void PLTE_free(PLTE_Chunk *this)
{
        free(this->palette);
        free(this);
}


/*
 * gAMA chunk (gamma)
 */
typedef struct {
        Chunk       head;
        double      gamma;
} gAMA_Chunk;

STD_CHUNK_GET(gAMA, _get gamma)
STD_CHUNK_SET(gAMA, _set gamma)
#define gAMA_free    free


/*
 * sRGB chunk
 */
typedef struct {
        Chunk       head;
        int         srgb_intent;
} sRGB_Chunk;

STD_CHUNK_GET(sRGB, _get srgb_intent)
STD_CHUNK_SET(sRGB, _set srgb_intent)
#define sRGB_free    free


/*
 * sBIT chunk (significant bits)
 */
typedef struct {
        Chunk         head;
        png_color_8p  sig_bit;
} sBIT_Chunk;

STD_CHUNK_GET(sBIT, _get sig_bit)
STD_CHUNK_SET(sBIT, _set sig_bit)
#define sBIT_free    free


/*
 * tRNS chunk (transparency)
 */
typedef struct {
        Chunk         head;
        png_bytep     trans;
        int           num_trans;
        png_color_16p trans_values;
} tRNS_Chunk;

STD_CHUNK_GET(tRNS, _get trans  _get num_trans  _get trans_values)
STD_CHUNK_SET(tRNS, _set trans  _set num_trans  _set trans_values)
#define tRNS_free    free


/*
 * hIST chunk (histogram)
 */
typedef struct {
        Chunk         head;
        png_uint_16p  histogram;
} hIST_Chunk;

STD_CHUNK_GET(hIST, _get histogram)
STD_CHUNK_SET(hIST, _set histogram)
#define hIST_free    free


/*
 * bKGD chunk (background color)
 */
typedef struct {
        Chunk         head;
        png_color_16p background;
} bKGD_Chunk;

STD_CHUNK_GET(bKGD, _get background)
STD_CHUNK_SET(bKGD, _set background)
#define bKGD_free    free


/*
 * oFFs chunk
 */
typedef struct {
        Chunk         head;
        png_uint_32   offset_x;
        png_uint_32   offset_y;
        int           unit_type;
} oFFs_Chunk;

STD_CHUNK_GET(oFFs, _get offset_x  _get offset_y  _get unit_type)
STD_CHUNK_SET(oFFs, _set offset_x  _set offset_y  _set unit_type)
#define oFFs_free    free


/*
 * pHYs chunk (physical pixel dimensions)
 */
typedef struct {
        Chunk         head;
        png_uint_32   res_x;
        png_uint_32   res_y;
        int           unit_type;
} pHYs_Chunk;

STD_CHUNK_GET(pHYs, _get res_x  _get res_y  _get unit_type)
STD_CHUNK_SET(pHYs, _set res_x  _set res_y  _set unit_type)
#define pHYs_free    free



/*** chunk table ***/
static const ChunkTable chunks[] = {
        REGIST_CHUNK(PLTE),  REGIST_CHUNK(gAMA),  REGIST_CHUNK(sRGB),
        REGIST_CHUNK(sBIT),  REGIST_CHUNK(tRNS),  REGIST_CHUNK(hIST),
        REGIST_CHUNK(bKGD),  REGIST_CHUNK(oFFs),  REGIST_CHUNK(pHYs),
};

/*
 * create new chunk.
 * ctbl->size must be begger than sizeof(Chunk)
 */
static
Chunk *new_chunk(const ChunkTable *ctbl, png_structp png, png_infop pnginfo)
{
        Chunk  *chunk;

        chunk = xmalloc(ctbl->size);
        chunk->name = ctbl->name;
        chunk->next = NULL;
        chunk->methods = ctbl->methods;
        chunk->methods.get(chunk, png, pnginfo);
        return chunk;
}


/*
 * make chunk list
 */
Chunk *preserve_png_chunks(png_structp png, png_infop pnginfo)
{
        Chunk *list = NULL, *cur = NULL, *c;
        const ChunkTable *ctbl;
        int  i;

        for(i = 0, ctbl = chunks; i < array_size(chunks); i++, ctbl++) {
                if(png_get_valid(png, pnginfo, ctbl->flag)) {
                        c = new_chunk(ctbl, png, pnginfo);
                        if(!cur) {
                                list = cur = c;
                        } else {
                                cur->next = c;
                                cur = c;
                        }
                }
        }
        return list;
}


/*
 * write chunks to PNG image
 */
void write_png_chunks(Chunk *chunks, png_structp png, png_infop pnginfo)
{
        if(!chunks) return;
        do {
                chunks->methods.set(chunks, png, pnginfo);
        } while((chunks = chunks->next));
}


void free_chunks(Chunk *chunks)
{
        Chunk  *next;
        if(!chunks) return;
        do {
                next = chunks->next;
                chunks->methods.free(chunks);
        } while((chunks = next));
}


/*
 * ====== Reading PNG ======
 */
typedef struct {
        png_uint_32  width;       /* IHDR chunk */
        png_uint_32  height;
        int          bit_depth;
        int          color_type;
        int          interlace_type;
        int          compression_type;
        int          filter_type;
        png_uint_32  rowbytes;
        png_bytepp   rows;        /* pixel data */
        png_bytep    data;
        Chunk        *chunks;     /* preserved chunks */
} Image;


static
void read_png_header(png_structp png, png_infop pnginfo, Image *img)
{
        png_get_IHDR(png, pnginfo,
                     &img->width, &img->height, &img->bit_depth,
                     &img->color_type, &img->interlace_type,
                     &img->compression_type, &img->filter_type);
}


static
void read_png_image_data(png_structp png, png_infop pnginfo, Image *img)
{
        png_bytepp   rows;
        png_bytep    data;
        png_uint_32  rowbytes, height;
        int  i;

        img->rowbytes = rowbytes = png_get_rowbytes(png, pnginfo);
        height = img->height;

        img->rows = rows = xmalloc(sizeof(png_bytep) * height);
        img->data = data = xmalloc(sizeof(png_byte) * rowbytes * height);

        for(i = 0; i < height; i++, data += rowbytes) {
                rows[i] = data;
        }

        png_read_image(png, rows);
}

#define free_image(img) do { \
        if((img)->rows) free((img)->rows); \
        if((img)->data) free((img)->data); \
        free_chunks((img)->chunks); \
} while(0)
#define init_image(img) ((img)->rows = NULL, \
                         (img)->data = NULL, \
                         (img)->chunks = NULL)


/*
 * open <filename> as a PNG file, and read image data into <img>.
 */
boolean read_png_file(char *filename, Image *img)
{
        FILE         *file;
        png_structp  png;
        png_infop    pnginfo;
        boolean      ret;

        _Try_ {
                file = fopen(filename, "rb");
                if(!file) {
                        error(0, errno, "%s", filename);
                        _Throw_(ERROR);
                }

                png = png_create_read_struct(PNG_LIBPNG_VER_STRING,
                                             NULL, NULL, NULL);
                if(!png) {
                        error(0, 0, "%s: %s",
                              filename, "png_create_read_struct failed.");
                        _Throw_(ERROR);
                }
                pnginfo = png_create_info_struct(png);
                if(!pnginfo) {
                        error(0, 0, "%s: %s",
                              filename, "png_create_info failed.");
                        _Throw_(ERROR);
                }

                if(setjmp(png->jmpbuf) != 0) _Throw_(ERROR);

                png_init_io(png, file);
                png_read_info(png, pnginfo);

                read_png_header(png, pnginfo, img);

                if(img->bit_depth < 8) png_set_packing(png);
                png_read_update_info(png, pnginfo);

                read_png_image_data(png, pnginfo, img);
                png_read_end(png, pnginfo);

                img->chunks = preserve_png_chunks(png, pnginfo);

                ret = true;
        }
        _Catch_(ERROR) {
                ret = false;
        }

        if(png) png_destroy_read_struct(&png, &pnginfo, NULL);
        if(file) fclose(file);
        return ret;
}



/*
 * ====== Writing PNG ======
 */
static
void write_png_header(Image *img, png_structp png, png_infop pnginfo)
{
        png_set_IHDR(png, pnginfo,
                     img->width, img->height, img->bit_depth,
                     img->color_type, img->interlace_type,
                     img->compression_type, img->filter_type);
}


/*
 * write <img> to <file> as a PNG image data.
 */
boolean write_png_image(Image *img, FILE *file)
{
        png_structp  png;
        png_infop    pnginfo;
        boolean      ret;

        _Try_ {
                png = png_create_write_struct(PNG_LIBPNG_VER_STRING,
                                              NULL, NULL, NULL);
                if(!png) {
                        error(0, 0, "png_create_write_struct failed.");
                        _Throw_(ERROR);
                }
                pnginfo = png_create_info_struct(png);
                if(!pnginfo) {
                        error(0, 0, "png_create_info failed.");
                        _Throw_(ERROR);
                }

                if(setjmp(png->jmpbuf) != 0) _Throw_(ERROR);

                png_init_io(png, file);
                png_set_filter(png, 0, PNG_FILTER_NONE | PNG_FILTER_SUB |
                               PNG_FILTER_PAETH);
                png_set_compression_level(png, DEFAULT_COMPRESSION_LEVEL);

                write_png_header(img, png, pnginfo);
                write_png_chunks(img->chunks, png, pnginfo);
                png_write_info(png, pnginfo);

                png_set_packing(png);

                png_write_flush(png);
                png_write_image(png, img->rows);

                png_write_end(png, pnginfo);
                ret = true;
        }
        _Catch_(ERROR) {
                ret = false;
        }

        if(png) png_destroy_write_struct(&png, &pnginfo);
        return ret;
}




/*
 * ====== Counter Image Generater ======
 */

/*
 * generate counter image from <img> and replace <img> with it.
 * <numbers> must consist on only decimal numbers.
 * If not, SEGV will be caused.
 */
void source_image_to_counter(Image *img, const char *numbers, int num_figure)
{
        const int  pixelsize  = img->rowbytes / img->width;
        const int  num_width  = img->width / 10;
        const int  figuresize = num_width * pixelsize;
        const int  height     = img->height;

        const int  new_width    = figuresize * num_figure;
        const int  new_rowbytes = new_width * pixelsize;

        png_bytep   src, dst, new_data;
        png_bytepp  rows;
        int   i, j;

        numbers += strlen(numbers) - num_figure;
        new_data = xmalloc(sizeof(png_byte) * new_rowbytes * height);

        for(i = 0, rows = img->rows; i < height; i++, rows++) {
                src = *rows;
                *rows = dst = new_data + new_rowbytes * i;
                for(j = 0; j < num_figure; j++) {
                        memcpy(dst + figuresize * j,
                               src + (numbers[j] - '0') * figuresize,
                               figuresize);
                }
        }

        free(img->data);
        img->width    = new_width;
        img->rowbytes = new_rowbytes;
        img->data     = new_data;
}




/*
 * ====== Counting ======
 */
void timeup()
{
}

static
boolean lock_fd(int fd)    /** POSIX signal & file lock **/
{
        struct sigaction  sig, old;
        struct flock      lock;

        memset(&sig, 0, sizeof(sig));
        sig.sa_handler = timeup;
        if(sigaction(SIGALRM, &sig, &old) == -1) {
                error(130, errno, "sigaction");
        }

        lock.l_type   = F_WRLCK;
        lock.l_whence = SEEK_SET;
        lock.l_start  = 0;
        lock.l_len    = 0;

        alarm(LOCK_TIMEOUT);
        if(fcntl(fd, F_SETLKW, &lock) == -1) {
                if(errno == EINTR) {
                        error(0, 0, "timeout");
                } else {
                        error(0, errno, "fcntl");
                }
                return false;
        }

        alarm(0);
        sigaction(SIGALRM, &old, NULL);
        return true;
}


static
char *new_counter(int num_figure)
{
        char  *buf, *p;

        buf = p = xmalloc(num_figure + 1);
        for( ; num_figure > 0; num_figure--) *(p++) = '0';
        *p = '\0';
        return buf;
}

static
char *read_count_file(int fd, off_t len, int num_figure)
{
        char     *buf, *p;
        ssize_t  n;
        int      i;

        buf = p = xmalloc(((num_figure > len) ? num_figure : len) + 2);
        for(i = len; i < num_figure; i++) *(p++) = '0';

        do {
                n = read(fd, p, len);
                if(n < 0) {
                        error(0, errno, "reed");
                        free(p);
                        return NULL;
                }
                p += n;
                len -= n;
        } while(len > 0);

        *p = '\0';
        return buf;
}


static
void increment(char *buf, int len)
{
        int   i;

        for(i = len, buf += len - 1; i > 0; i--, buf--) {
                if(++(*buf) <= '9') return;
                *buf = '0';
        }

        /** overflow **/
        buf++;
        *(buf++) = '1';
        for(i = 0; i < len; i++) *(buf++) = '0';
        *buf = '\0';
}


static
void write_count_file(int fd, const char *buf)
{
        ssize_t  len = strlen(buf);
        ssize_t  n;

        if(lseek(fd, 0, SEEK_SET) == -1) {
                error(0, errno, "lseek");
                return;
        }

        do {
                n = write(fd, buf, len);
                if(n < 0) {
                        error(0, errno, "write");
                        return;
                }
                buf += n;
                len -= n;
        } while(len > 0);
}


/*
 * count <filename>.
 * Return is string of current count number.
 */
char *count(const char *filename, int num_figure)
{
        int    fd;
        off_t  len;
        char   *buf = NULL;

        _Try_ {
                fd = open(filename, O_RDWR | O_CREAT, FILE_MODE);
                if(fd == -1) {
                        error(0, errno, "open: %s", filename);
                        _Throw_(ERROR);
                }
                if(!lock_fd(fd)) _Throw_(ERROR);

                len = lseek(fd, 0, SEEK_END);
                if(len == -1 || lseek(fd, 0, SEEK_SET) == -1) {
                        error(0, errno, "lseek");
                        _Throw_(ERROR);
                }

                buf = (len == 0) ? new_counter(num_figure)
                        : read_count_file(fd, len, num_figure);
                if(!buf) _Throw_(ERROR);

                increment(buf, (num_figure > len) ? num_figure : len);
                write_count_file(fd, buf);
        }
        _Catch_(ERROR) {
        }

        if(fd != -1) close(fd);
        return buf;
}




/*
 * ====== Parse Arguments ======
 */
typedef struct {
        boolean  cgi;            /* invoked by CGI? */
        char     *image_path;    /* source image path */
        char     *count_path;    /* counter file */
        int      num_figure;     /* the number of figures */
} Config;


static
char *split(char *src, char delim)
{
        char  c;
        while((c = *src) && c != delim) src++;
        *src = '\0';
        return c ? src + 1 : NULL;
}

static
char *concat4(const char *s1, const char *s2, const char *s3, const char *s4)
{
        char  c, *buf, *p;
        int  len = 0;

        if(s1) len += strlen(s1);
        if(s2) len += strlen(s2);
        if(s3) len += strlen(s3);
        if(s4) len += strlen(s4);
        p = buf = xmalloc(len + 1);

        if(s1) while((c = *s1)) *(p++) = c, s1++;
        if(s2) while((c = *s2)) *(p++) = c, s2++;
        if(s3) while((c = *s3)) *(p++) = c, s3++;
        if(s4) while((c = *s4)) *(p++) = c, s4++;
        *p = '\0';
        return buf;
}


static
char *get_user_dir(const char *user)
{
        struct stat     st;
        struct passwd  *pw;
        char  *buf;

        if(!user) {  /** implied **/
                return xstrdup(DEFAULT_USER_DIR "/");
        }

        if(strcmp(user, USER_ROOT) == 0) {  /** reserved **/
                error(0, 0, "reserved user name: %s", user);
                return NULL;
        }

        /** DEFAULT_ALIAS_DIR/<user> **/
        buf = concat4(DEFAULT_ALIAS_DIR "/", user, "/", NULL);
        if(stat(buf, &st) == 0 && S_ISDIR(st.st_mode)) return buf;
        free(buf);

#ifndef SINGLE_USER_ONLY
        /** ~<user>/USER_DIR **/
        pw = getpwnam(user);
        if(pw) {
                buf = concat4(pw->pw_dir, "/" USER_DIR "/", NULL, NULL);
                if(stat(buf, &st) == 0 && S_ISDIR(st.st_mode)) return buf;
                free(buf);
        }
#endif
        error(0, 0, "invalid user: %s", user);
        return NULL;
}

static
char *get_image_path(const char *userdir, const char *image)
{
        char  *buf;
        struct stat   st;

        if(!image) {  /** implied **/
                image = DEFAULT_IMAGE;
        }

        /** <user_dir>/IMAGE_DIR/<image>.png **/
        buf = concat4(userdir, IMAGE_DIR "/", image, SUFFIX);
        if(stat(buf, &st) == 0 && S_ISREG(st.st_mode)) return buf;
        free(buf);

        /** DEFAULT_IMAGE_DIR/<image>.png **/
        return concat4(DEFAULT_IMAGE_DIR "/", image, SUFFIX, NULL);
}

static
char *get_count_path(const char *userdir, const char *name)
{
        /** <user_dir>/<name> **/
        return concat4(userdir, name, NULL, NULL);
}


static
boolean make_config(char *user, char *image, char *name, Config *conf)
{
        char  *user_dir, *p;
        int   n;

        /** check name **/
        if(*name == '\0') {
                error(0, 0, "null name");
                return false;
        }
        if(*name == '_') {
                p = split(++name, '_');
                if(!p) {
                        error(0, 0, "name error");
                        return false;
                }
                n = atoi(name);
                if(n >= 1) conf->num_figure = n;
                name = p;
        }

        if(*name == '.' ||                   /** reserved **/
           strcmp(name, IMAGE_DIR) == 0 ||
           strcmp(name, ALIAS_DIR) == 0) {
                error(0, 0, "reserved counter name: %s", name);
                return false;
        }

        user_dir = get_user_dir(user);
        if(!user_dir) return false;

        conf->image_path = get_image_path(user_dir, image);
        conf->count_path = get_count_path(user_dir, name);

        free(user_dir);
        return true;
}

#define free_config(c) do { \
        if((c)->image_path) free((c)->image_path); \
        if((c)->image_path) free((c)->count_path); \
} while(0)
#define init_config(c) ((c)->num_figure = DEFAULT_NUM_FIGURE, \
                        (c)->image_path = (c)->count_path = NULL)


static
boolean parse_argument(char *src, Config *conf)
{
        char  *next, *user = NULL, *image = NULL, *name = NULL;
        int   n;

        if(*(src++) != '/') {
                error(0, 0, "is not absolute path form");
                return false;
        }
        n = strlen(src) - (sizeof(SUFFIX)-1);
        if(n < 0) {
                error(0, 0, "argument too short");
                return false;
        }
        if(strcmp(&src[n], SUFFIX) != 0) {
                error(0, 0, "missing suffix `" SUFFIX "'");
                return false;
        }
        src[n] = '\0';

        while(1) {
                next = split(src, '/');
                if(!next) {                   /* last argument */
                        name = src;
                        break;
                }
                else if(*src == '-') {        /* specify image */
                        image = src + 1;
                }
                else {                        /* specify user */
                        user = src;
                }
                src = next;
        }

        return make_config(user, image, name, conf);
}


boolean get_argument(int argc, char **argv, Config *conf)
{
        char  *src;
        boolean  ret;

        src = getenv("PATH_INFO");
        if(src) {
                conf->cgi = true;
        } else {
                if(argc != 2) {
                        error(0, 0, "missing arguments");
                        return false;
                }
                conf->cgi = false;
                src = argv[1];
        }

        src = xstrdup(src);
        ret = parse_argument(src, conf);

        free(src);
        return ret;
}




/*
 * ====== ENTRY ======
 */
int main(int argc, char **argv)
{
        Config  conf;
        Image   img;
        char    *buf;
        int     ret;

        program_name = argv[0];
        init_config(&conf);
        init_image(&img);

        _Try_ {
                if(!get_argument(argc, argv, &conf)) _Throw_(ERROR);
                if(!read_png_file(conf.image_path, &img)) _Throw_(ERROR);

                buf = count(conf.count_path, conf.num_figure);
                if(!buf) _Throw_(ERROR);

                source_image_to_counter(&img, buf, conf.num_figure);

                if(conf.cgi) printf("Content-Type: image/png\n\n");
                write_png_image(&img, stdout);

                free(buf);
                ret = 0;
        }
        _Catch_(ERROR) {
                ret = 1;
        }

        free_image(&img);
        free_config(&conf);
        return ret;
}
